Introduce --ctl-fd[-ack] options to pass open file descriptors numbers
from command line. Extend perf-record.txt file with --ctl-fd[-ack]
options description. Document possible usage model introduced by
--ctl-fd[-ack] options by providing example bash shell script.

Signed-off-by: Alexey Budankov <alexey.budan...@linux.intel.com>
---
 tools/perf/Documentation/perf-record.txt | 40 ++++++++++++++++++++++++
 tools/perf/builtin-record.c              | 10 ++++++
 tools/perf/util/record.h                 |  2 ++
 3 files changed, 52 insertions(+)

diff --git a/tools/perf/Documentation/perf-record.txt 
b/tools/perf/Documentation/perf-record.txt
index a84376605805..b0e9b7a1761e 100644
--- a/tools/perf/Documentation/perf-record.txt
+++ b/tools/perf/Documentation/perf-record.txt
@@ -627,6 +627,46 @@ option. The -e option and this one can be mixed and 
matched.  Events
 can be grouped using the {} notation.
 endif::HAVE_LIBPFM[]
 
+--ctl-fd::
+--ctl-fd-ack::
+Listen on ctl-fd descriptor for command to control measurement ('enable': 
enable events,
+'disable': disable events). Measurements can be started with events disabled 
using
+--delay=-1 option. Optionally send control command completion ('ack\n') to 
fd-ack descriptor
+to synchronize with the controlling process. Example of bash shell script to 
enable and
+disable events during measurements:
+
+#!/bin/bash
+
+ctl_dir=/tmp/
+
+ctl_fifo=${ctl_dir}perf_ctl.fifo
+test -p ${ctl_fifo} && unlink ${ctl_fifo}
+mkfifo ${ctl_fifo}
+exec {ctl_fd}<>${ctl_fifo}
+
+ctl_ack_fifo=${ctl_dir}perf_ctl_ack.fifo
+test -p ${ctl_ack_fifo} && unlink ${ctl_ack_fifo}
+mkfifo ${ctl_ack_fifo}
+exec {ctl_fd_ack}<>${ctl_ack_fifo}
+
+perf record -D -1 -e cpu-cycles -a                        \
+            --ctl-fd ${ctl_fd} --ctl-fd-ack ${ctl_fd_ack} \
+            -- sleep 30 &
+perf_pid=$!
+
+sleep 5  && echo 'enable' >&${ctl_fd} && read -u ${ctl_fd_ack} e1 && echo 
"enabled(${e1})"
+sleep 10 && echo 'disable' >&${ctl_fd} && read -u ${ctl_fd_ack} d1 && echo 
"disabled(${d1})"
+
+exec {ctl_fd_ack}>&-
+unlink ${ctl_ack_fifo}
+
+exec {ctl_fd}>&-
+unlink ${ctl_fifo}
+
+wait -n ${perf_pid}
+exit $?
+
+
 SEE ALSO
 --------
 linkperf:perf-stat[1], linkperf:perf-list[1], linkperf:perf-intel-pt[1]
diff --git a/tools/perf/builtin-record.c b/tools/perf/builtin-record.c
index 0394e068dde8..8494ce964738 100644
--- a/tools/perf/builtin-record.c
+++ b/tools/perf/builtin-record.c
@@ -1749,6 +1749,9 @@ static int __cmd_record(struct record *rec, int argc, 
const char **argv)
                perf_evlist__start_workload(rec->evlist);
        }
 
+       if (evlist__initialize_ctlfd(rec->evlist, opts->ctl_fd, 
opts->ctl_fd_ack))
+               goto out_child;
+
        if (opts->initial_delay) {
                pr_info(EVLIST_DISABLED_MSG);
                if (opts->initial_delay > 0) {
@@ -1895,6 +1898,7 @@ static int __cmd_record(struct record *rec, int argc, 
const char **argv)
                record__synthesize_workload(rec, true);
 
 out_child:
+       evlist__finalize_ctlfd(rec->evlist);
        record__mmap_read_all(rec, true);
        record__aio_mmap_read_sync(rec);
 
@@ -2380,6 +2384,8 @@ static struct record record = {
                },
                .mmap_flush          = MMAP_FLUSH_DEFAULT,
                .nr_threads_synthesize = 1,
+               .ctl_fd              = -1,
+               .ctl_fd_ack          = -1,
        },
        .tool = {
                .sample         = process_sample_event,
@@ -2581,6 +2587,10 @@ static struct option __record_options[] = {
                "libpfm4 event selector. use 'perf list' to list available 
events",
                parse_libpfm_events_option),
 #endif
+       OPT_INTEGER(0, "ctl-fd", &record.opts.ctl_fd,
+                   "Listen on fd descriptor for command to control measurement 
('enable': enable events, 'disable': disable events)"),
+       OPT_INTEGER(0, "ctl-fd-ack", &record.opts.ctl_fd_ack,
+                  "Send control command completion ('ack') to fd ack 
descriptor"),
        OPT_END()
 };
 
diff --git a/tools/perf/util/record.h b/tools/perf/util/record.h
index da138dcb4d34..4cb72a478af1 100644
--- a/tools/perf/util/record.h
+++ b/tools/perf/util/record.h
@@ -70,6 +70,8 @@ struct record_opts {
        int           mmap_flush;
        unsigned int  comp_level;
        unsigned int  nr_threads_synthesize;
+       int           ctl_fd;
+       int           ctl_fd_ack;
 };
 
 extern const char * const *record_usage;
-- 
2.24.1


Reply via email to